## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 10;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

# There are no ELF objects in this package, so turn off debuginfo generation.
%global debug_package %{nil}

Name:           libdivide
Version:        5.0
Release:        %autorelease
Summary:        Optimized integer division

License:        Zlib OR BSL-1.0
URL:            https://libdivide.com/
Source0:        https://github.com/ridiculousfish/libdivide/archive/%{version}/libdivide-%{version}.tar.gz

BuildRequires:  gcc-c++
BuildRequires:  cmake

%global _description %{expand:
This package contains a header-only C/C++ library for optimizing integer
division. Integer division is one of the slowest instructions on most CPUs,
e.g. on current x64 CPUs a 64-bit integer division has a latency of up to 90
clock cycles whereas a multiplication has a latency of only 3 clock cycles.
libdivide allows you to replace expensive integer divsion instructions by a
sequence of shift, add and multiply instructions that will calculate the
integer division much faster.

On current CPUs you can get a speedup of up to 10x for 64-bit integer division
and a speedup of up to to 5x for 32-bit integer division when using libdivide.
libdivide also supports SSE2, AVX2 and AVX512 vector division which provides an
even larger speedup.}

%description %_description


%package        devel
Summary:        Development files for libdivide

# Header-only library
Provides:       libdivide-static = %{version}-%{release}

%description    devel %_description


%prep
%autosetup

# Disable -Werror
sed -i 's/;-Werror//;/-Werror/d' CMakeLists.txt


%build
%cmake
%cmake_build


%install
%cmake_install


%check
%ctest


%files devel
%license LICENSE.txt
%doc CHANGELOG.md
%doc README.md
%doc doc

%{_includedir}/libdivide.h
%{_libdir}/cmake/libdivide/


%changelog
* Fri Aug 05 2022 Benjamin A. Beasley <code@musicinmybrain.net> 5.0-10
- Update License to SPDX

* Thu Jul 21 2022 Fedora Release Engineering <releng@fedoraproject.org> 5.0-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_37_Mass_Rebuild

* Sun Jul 17 2022 Jerry James <loganjerry@gmail.com> 5.0-8
- Update README.md.

* Thu Jan 20 2022 Fedora Release Engineering <releng@fedoraproject.org> 5.0-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_36_Mass_Rebuild

* Fri Dec 10 2021 Benjamin A. Beasley <code@musicinmybrain.net> 5.0-6
- Reduce macro indirection in the spec file

* Fri Dec 10 2021 Benjamin A. Beasley <code@musicinmybrain.net> 5.0-5
- Style tweaks according to personal preference

* Fri Dec 10 2021 Benjamin A. Beasley <code@musicinmybrain.net> 5.0-4
- Switch URL from HTTP to HTTPS

* Thu Jul 22 2021 Fedora Release Engineering <releng@fedoraproject.org> - 5.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_35_Mass_Rebuild

* Sun Jul 18 2021 Jerry James <loganjerry@gmail.com> - 5.0-1
- Version 5.0

* Tue Mar  9 2021 Jerry James <loganjerry@gmail.com> - 4.0.0-1
- Version 4.0.0

* Tue Jan 26 2021 Fedora Release Engineering <releng@fedoraproject.org> - 3.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_34_Mass_Rebuild

* Tue Jul 28 2020 Fedora Release Engineering <releng@fedoraproject.org> - 3.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_33_Mass_Rebuild

* Wed Jan 29 2020 Fedora Release Engineering <releng@fedoraproject.org> - 3.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_32_Mass_Rebuild

* Wed Oct 16 2019 Jerry James <loganjerry@gmail.com> - 3.0-1
- New upstream version
- Package cannot be noarch due to the cmake files

* Mon Sep 16 2019 Jerry James <loganjerry@gmail.com> - 2.0-1
- Initial RPM

